#include <stdio.h>
#include <stdlib.h>
#include <string.h>

char *my_tokenize(const char *s, size_t size, char delim)
{
	char *ret = malloc(1024);
	int i = 0;

	if (s[0] == '\0')
		return NULL;

	/* sanitize? */
	strncpy(ret, s, size);
	ret[size] = '\0';

	while (ret[i] != '\0')
	{
		if (ret[i] == delim)
			ret[i] = '\0';
		i++;
	}

	return ret;
}

int main(int argc, char **argv)
{
	const char str[] = "ana,are,mere";
	char *p;

	p = my_tokenize(str, sizeof(str),',');
	printf("%s\n", p);
	
	if (argc > 1) {
		p = my_tokenize(argv[1], 65535, ';');
		printf("%s\n", p);
	}

	my_tokenize(NULL, 0, '\0');

	return 0;
}
